#include <gtkmm/label.h>
#include <gtkmm/button.h>
#include <gtkmm/radiobutton.h>
#include <gtkmm/table.h>
#include <gtkmm/box.h>
#include <gtkmm/window.h>
#include <gtkmm/main.h>
#include "igra.h"

using namespace Gtk;
class Prozor : public Window{
private:
                RadioButton r1, r2;
                VBox vbox,rad;
		HBox hbox,dug;
                Label lab;
                Table tab;
                Button *dugme,nova,izlaz;
                Igrac *pok1,*pok2;
                bool lock;
		int cnt;
public:                 
                Prozor();
                virtual ~Prozor();
protected:
                virtual void kliknuto(int);
                virtual void nova_igra();
		virtual void kraj_igre();
};

Prozor::Prozor():tab(8,8,FALSE),vbox(FALSE,5),rad(FALSE,5),dug(TRUE,5),
                                                   hbox(FALSE,5),r1("Човек"),r2("Рачунар"){
  set_title("Игра");
  set_border_width(10);
  set_resizable(false);
  
  RadioButton::Group grupa = r1.get_group();
  r2.set_group(grupa);
  r2.set_active();
   izlaz.add_pixlabel("opera.xpm","Излаз");  
   nova.add_pixlabel("mozicon16.xpm","Нова игра");
   pok1 = new Zivi_igrac('X');
   pok2 =NULL;
   cnt = 1;
  dugme = new Button[9];
  lock = false;
  for(int i = 0,j=0 ;i<9; i++){
     if(i%3==0)j++;
     dugme[i].set_label("	" );
     dugme[i].signal_clicked().connect(SigC::bind<int>( SigC::slot(*this, &Prozor::kliknuto),i) );    
     tab.attach(dugme[i],i%3,(i%3)+1,j,j+1);
     dugme[i].show();
  }
  
  nova.signal_clicked().connect(SigC::slot(*this, &Prozor::nova_igra));
  izlaz.signal_clicked().connect(SigC::slot(*this, &Prozor::kraj_igre));
  r1.signal_clicked().connect(SigC::slot(*this, &Prozor::nova_igra));
  r2.signal_clicked().connect(SigC::slot(*this, &Prozor::nova_igra));
  
  nova_igra();
  rad.pack_start(r1,TRUE,FALSE,0);
  rad.pack_start(r2,TRUE,FALSE,0);
  hbox.pack_start(tab,PACK_EXPAND_WIDGET,0);
  hbox.pack_start(rad,TRUE,FALSE,0);
  
  dug.pack_start(nova,PACK_EXPAND_WIDGET,1);
  dug.pack_start(izlaz,PACK_EXPAND_WIDGET,1);
  
  vbox.pack_start(lab,TRUE,FALSE,0);
  vbox.pack_start(hbox,TRUE,FALSE,0);
  vbox.pack_start(dug,TRUE,FALSE,0);
  
  lab.show();
  r1.show();
  r2.show();
  nova.show();
  izlaz.show();
  tab.show();
  hbox.show();
  dug.show();
  rad.show();
  vbox.show();
  add(vbox);
}

Prozor::~Prozor(){  }

void Prozor::nova_igra(){
     lab.set_label(" ");
     for(int i=0;i<9;i++)dugme[i].set_label("	");
      if(r1.get_active())
           pok2 = new Zivi_igrac('O');
       if(r2.get_active())    
            pok2 = new CPU_igrac('O');
	    Igrac::reset();
	  cnt=1;  
     lock = false;
}

void Prozor::kraj_igre(){
   exit(0);
}

void Prozor::kliknuto(int data){
 if(lock)return;
 
 if (typeid(*pok2)==typeid(CPU_igrac)) 	   
  try{
    if(pok1->odigraj_potez(data)>=0)
               dugme[data].set_label(pok1->labela());
        else return;
         Igrac::provera(pok1);
          dugme[pok2->odigraj_potez()].set_label(pok2->labela());
        Igrac::provera(pok2);
  } catch(char s){
       Glib::ustring u;
        u+="Победник је ";
        u+=s;
        lab.set_label(u);
        lock = true;
     }
     
  else
     try{
  if(cnt%2){
    if(pok1->odigraj_potez(data)>=0)
               dugme[data].set_label(pok1->labela());
      else return;
    }
    
    else{
    if(pok2->odigraj_potez(data)>=0)
               dugme[data].set_label(pok2->labela());
      else return;
    }  
     cnt++;
     
      Igrac::provera(pok1);
      Igrac::provera(pok2);
        
 }catch(char s){
  Glib::ustring u;
  u+="Победник је играч ";
  u+=s;
  if(s!='n')
     lab.set_label(u);
  else lab.set_label("Нема победника");
   cnt==1; 
   lock = true;
  }
}

int main (int argc, char *argv[]){
  Main kit(argc, argv);
  Prozor pr;
  Main::run(pr);
  return 0;
}
